#include "euler.hpp"
#include "euler2.hpp"
#include "regression.hpp"


const int nb_valeurs = 8;
const int N_MC = 1000;
const double T = 5;


int main(void)
{
  double pas = 0.1;
  Euler X(pas);
  std::vector<double> x(nb_valeurs), y(nb_valeurs);

  std::cout << "Erreur dans le schéma d'Euler, avec sigma constant.\n";
  std::cout << "Pas\tErreur forte\n";
  for (int i=0; i<nb_valeurs; i++)
	{
	  double err_forte = X.erreur_forte(T, N_MC);
	  std::cout << X.access_dt() <<  "\t" << err_forte << "\n";
	  x[i] = log(X.access_dt());
	  y[i] = log(err_forte);
	  pas /= 2;
	  X.change_pas(pas);
	}

  std::cout << "Erreur forte en dt^" << coeff_regression(x,y) << "\n\n\n";
  


  
  pas = 0.1;
  Euler2 X2(pas);

  std::cout << "Erreur dans le schéma d'Euler, avec sigma non constant.\n";
  std::cout << "Pas\tErreur forte\n";
  for (int i=0; i<nb_valeurs; i++)
	{
	  double err_forte = X2.erreur_forte(T, N_MC);
	  std::cout << X2.access_dt() <<  "\t" << err_forte << "\n";
	  x[i] = log(X2.access_dt());
	  y[i] = log(err_forte);
	  pas /= 2;
	  X2.change_pas(pas);
	}

  std::cout << "Erreur forte en dt^" << coeff_regression(x,y) << "\n";
  
  return 0;
}

